CLEAR
_SCREEN.FONTNAME="fixedsys"

* oCryptPak is private and not local to be able to use it in PROCEDURES
PRIVATE oCryptPak

LOCAL lcTxt, lcRes, lcOK
SET CLASSLIB TO CryptPak.vcx

*** All work is done using CryptPak object ***
oCryptPak = CREATEOBJECT("CryptPak")

*** CRC32 ***
* CRC32 is 32-bit checksum of string passed as parameter to CRC32 method
?
?[CRC32 "" -> ]+NumToHex(oCryptPak.CRC32(""))
?[CRC32 "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789" -> ]+NumToHex(oCryptPak.CRC32("ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789"))

*** Message digests ***
* SHA1 and MD5 are message digests standard. You can use it
* to be sure, that nobody change some data. It almost impossible
* (there are mathematical reason why it is almost impossible)
* to change data in such way, that message digest doesn't change.
* Message digest is "signature" of string

*** SHA1 ***
?
DigestTest("SHA1", ;
	"abc", ;
	oCryptPak.SHA1("abc"), ;
	"A9993E36 4706816A BA3E2571 7850C26C 9CD0D89D ")
DigestTest("SHA1", ;
	"abcdbcdecdefdefgefghfghighijhijkijkljklmklmnlmnomnopnopq", ;
	oCryptPak.SHA1("abcdbcdecdefdefgefghfghighijhijkijkljklmklmnlmnomnopnopq"), ;
	"84983E44 1C3BD26E BAAE4AA1 F95129E5 E54670F1 ")

*** MD5 ***
?
DigestTest("MD5", ;
	"", ;
	oCryptPak.MD5(""), ;
	"d41d8cd9 8f00b204 e9800998 ecf8427e ")
DigestTest("MD5", ;
	"a", ;
	oCryptPak.MD5("a"), ;
	"0cc175b9 c0f1b6a8 31c399e2 69772661 ")
DigestTest("MD5", ;
	"abc",;
	oCryptPak.MD5("abc"), ;
	"90015098 3cd24fb0 d6963f7d 28e17f72 ")
DigestTest("MD5", ;
	"message digest", ;
	oCryptPak.MD5("message digest"), ;
	"f96b697d 7cb7938d 525a2f31 aaf161d0 ")
DigestTest("MD5", ;
	"abcdefghijklmnopqrstuvwxyz", ;
	oCryptPak.MD5("abcdefghijklmnopqrstuvwxyz"), ;
	"c3fcd3d7 6192e400 7dfb496c ca67e13b ")
DigestTest("MD5", ;
	"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789", ;
	oCryptPak.MD5("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"), ;
	"d174ab98 d277d9f5 a5611c2c 9f419d9f ")
DigestTest("MD5", ;
	"12345678901234567890123456789012345678901234567890123456789012345678901234567890", ;
	oCryptPak.MD5("12345678901234567890123456789012345678901234567890123456789012345678901234567890"), ;
	"57edf4a2 2be3c955 ac49da2e 2107b67a ")

*** Encryption and decryption ***
*** BlowFish ***
* For encryption you need just data and password, for decryption
* you need also LENGTH of encrypted data !!!! (this is due to fact,
* that encryption is done in blocks)

* As example and test I am using here two directories (here are the same) :
#DEFINE EncrDir "D:\Program Files\Microsoft Visual Studio\Vfp98\"
#DEFINE KeyDir  "D:\Program Files\Microsoft Visual Studio\Vfp98\"
* and I encrypt every file from EncrDir with every file from KeyDir -
* I am using FileToStr function from 6.0 - this is just test that everythign
* is O.K.

?
TestNo = 0
FOR j = 1 TO ADIR(aKeyName, KeyDir+"*.*")
	k = FILETOSTR(KeyDir+aKeyName(j,1))
	FOR i = 1 TO ADIR(aEncrName, EncrDir+"*.*")
		T = FILETOSTR(EncrDir+aEncrName(i,1))
		TestNo = TestNo+1
* we call TestEncryptAll with pasword, string to encrypt, and other parameters - just for display on screen
		DO TestEncryptAll WITH k,T, aEncrName(i,1), aKeyName(j,1), TestNo
	ENDFOR
ENDFOR

oCryptPak = NULL
RETURN

FUNCTION NumToHex (pnNumber)
RETURN TRAN(IIF(pnNumber<0,0xffffffff+1,0)+pnNumber,"@0")

FUNCTION CHRTOHEX (pcString)
LOCAL i, N, ret
ret = ""
FOR i = 1 TO LEN(pcString)
	N = ASC(SUBSTR(pcString,i,1))
	ret = ret+ ;
		SUBSTR("0123456789ABCDEF",INT(N/16)+1,1)+;
		SUBSTR("0123456789ABCDEF",MOD(N,16)+1,1)+;
		IIF(MOD(i,4)=0," ","")
ENDFOR
RETURN ret

*****************************************************************

FUNCTION DigestTest(pMethod, pData, pDigest, pDigestOK)
?pMethod+" digest for  "+pData+" is "+CHRTOHEX(pDigest)+" : "+IIF(CHRTOHEX(pDigest)==UPPER(pDigestOK),"O.K.","BAD")
RETURN

*****************************************************************

PROCEDURE TestEncryptAll (k, p, np, nk, nt)
?LTRIM(STR(nt))+".test : encrypting "+np+" ("+LTRIM(STR(LEN(p)))+" bytes) with key "+nk++" ("+LTRIM(STR(LEN(k)))+" bytes)"
DO TestEncrypt WITH k, p
ENDPROC

* THIS IS THE MAIN PROCEDURE FOR EN/DECRYPTING
* We are also testing speed of this process
PROCEDURE TestEncrypt (sKey, sPlain)
LOCAL ln, t1, t2
ln = LEN(sPlain)
t1 = SECONDS()
sEncr  = oCryptPak.ENCRYPT(sKey, sPlain)
sDecr  = LEFT(oCryptPak.Decrypt(sKey, sEncr),ln)
t2 = SECONDS()
??IIF(sDecr==sPlain," O.K. "," ERROR ")+ltrim(STR(LEN(sPlain)/(t2-t1)))+" char/sec"
IF NOT sDecr==sPlain
	MESSAGEBOX("ERROR")
	SUSP
ENDIF
RETURN
